library action;

import 'entity_store.dart';
import '../../src/schema_v1_pb2.dart';

abstract class Action {
  final EntityStore entityStore;
  final Entity subject;

  final int transactionId;

  Action(this.entityStore, this.transactionId, this.subject);

  void perform();

  void undo();
}

class InsertAction extends Action {
  InsertAction(entityStore, transactionId, subject):
      super(entityStore, transactionId, subject);

  @override
  void perform() {
    var existing = entityStore.entityByKey(subject.key);
    if (existing != null)
      throw "Entity already in datastore";
    entityStore.insert(subject);


  }

  @override
  void undo() {
    // TODO: implement undo
  }
}

